'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _asyncGenerator2 = require('babel-runtime/helpers/asyncGenerator');

var _asyncGenerator3 = _interopRequireDefault(_asyncGenerator2);

exports.default = initGetLifecycle;

var _config = require('./config');

var _appManagerError = require('./app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initGetLifecycle(fragments, loadScript, getSlotElement, options) {
  var createLifecycle = function () {
    var _ref = _asyncGenerator3.default.wrap( /*#__PURE__*/_regenerator2.default.mark(function _callee4(slotName, fragmentName, initialRender) {
      var updateStatus = function () {
        var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(statusDetails) {
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  _context.next = 3;
                  return script.onUpdateStatus(statusDetails);

                case 3:
                  _context.next = 7;
                  break;

                case 5:
                  _context.prev = 5;
                  _context.t0 = _context['catch'](0);

                case 7:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this, [[0, 5]]);
        }));

        return function updateStatus(_x4) {
          return _ref2.apply(this, arguments);
        };
      }();

      var unmount = function () {
        var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
          var unmountSlotElement, amError;
          return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  unmountSlotElement = void 0;
                  _context2.prev = 1;
                  _context2.next = 4;
                  return getSlotElement(slotName, fragmentName);

                case 4:
                  unmountSlotElement = _context2.sent;
                  _context2.next = 12;
                  break;

                case 7:
                  _context2.prev = 7;
                  _context2.t0 = _context2['catch'](1);
                  _context2.next = 11;
                  return updateStatus((0, _config.getErrorStatusDetails)(_context2.t0));

                case 11:
                  throw _context2.t0;

                case 12:
                  if (!unmountSlotElement) {
                    _context2.next = 24;
                    break;
                  }

                  _context2.prev = 13;
                  _context2.next = 16;
                  return script.unmount(unmountSlotElement);

                case 16:
                  _context2.next = 24;
                  break;

                case 18:
                  _context2.prev = 18;
                  _context2.t1 = _context2['catch'](13);
                  amError = new _appManagerError2.default(_context2.t1, (0, _assign2.default)({}, errData, {
                    level: _constants.levels.ERROR,
                    code: 'unmount',
                    recoverable: true
                  }));
                  _context2.next = 23;
                  return updateStatus((0, _config.getErrorStatusDetails)(amError));

                case 23:
                  throw amError;

                case 24:
                case 'end':
                  return _context2.stop();
              }
            }
          }, _callee2, this, [[1, 7], [13, 18]]);
        }));

        return function unmount() {
          return _ref3.apply(this, arguments);
        };
      }();

      var handleError = function () {
        var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(err) {
          return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.prev = 0;
                  _context3.next = 3;
                  return updateStatus((0, _config.getErrorStatusDetails)(err));

                case 3:
                  _context3.next = 5;
                  return unmount();

                case 5:
                  _context3.next = 9;
                  break;

                case 7:
                  _context3.prev = 7;
                  _context3.t0 = _context3['catch'](0);

                case 9:
                case 'end':
                  return _context3.stop();
              }
            }
          }, _callee3, this, [[0, 7]]);
        }));

        return function handleError(_x5) {
          return _ref4.apply(this, arguments);
        };
      }();

      var script, errData, mountSlotElement, amError, stop, _amError;

      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              script = cachedScripts[fragmentName];

              if (script) {
                _context4.next = 3;
                break;
              }

              return _context4.abrupt('return');

            case 3:
              errData = {
                source: 'state_changer',
                fragment: fragmentName,
                slot: slotName
              };
              _context4.next = 6;
              return _asyncGenerator3.default.await(updateStatus(loadingStatusDetails));

            case 6:
              mountSlotElement = void 0;
              _context4.prev = 7;
              _context4.next = 10;
              return _asyncGenerator3.default.await(getSlotElement(slotName, fragmentName));

            case 10:
              mountSlotElement = _context4.sent;
              _context4.next = 18;
              break;

            case 13:
              _context4.prev = 13;
              _context4.t0 = _context4['catch'](7);
              _context4.next = 17;
              return _asyncGenerator3.default.await(updateStatus((0, _config.getErrorStatusDetails)(_context4.t0)));

            case 17:
              throw _context4.t0;

            case 18:
              if (!mountSlotElement) {
                _context4.next = 35;
                break;
              }

              _context4.prev = 19;

              if (!initialRender) {
                _context4.next = 25;
                break;
              }

              _context4.next = 23;
              return _asyncGenerator3.default.await(script.hydrate(mountSlotElement));

            case 23:
              _context4.next = 27;
              break;

            case 25:
              _context4.next = 27;
              return _asyncGenerator3.default.await(script.render(mountSlotElement));

            case 27:
              _context4.next = 35;
              break;

            case 29:
              _context4.prev = 29;
              _context4.t1 = _context4['catch'](19);
              amError = new _appManagerError2.default(_context4.t1, (0, _assign2.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'mount',
                recoverable: true
              }));
              _context4.next = 34;
              return _asyncGenerator3.default.await(handleError(_context4.t1));

            case 34:
              throw amError;

            case 35:
              stop = void 0;

            case 36:
              if (stop) {
                _context4.next = 75;
                break;
              }

            case 37:
              if (!true) {
                _context4.next = 51;
                break;
              }

              _context4.prev = 38;
              _context4.next = 41;
              return;

            case 41:
              stop = _context4.sent;
              return _context4.abrupt('break', 51);

            case 45:
              _context4.prev = 45;
              _context4.t2 = _context4['catch'](38);
              _context4.next = 49;
              return _asyncGenerator3.default.await(updateStatus((0, _config.getErrorStatusDetails)(_context4.t2)));

            case 49:
              _context4.next = 37;
              break;

            case 51:
              _context4.next = 53;
              return _asyncGenerator3.default.await(updateStatus(defaultStatusDetails));

            case 53:
              _context4.next = 55;
              return;

            case 55:
              stop = _context4.sent;
              _context4.next = 58;
              return _asyncGenerator3.default.await(updateStatus(loadingStatusDetails));

            case 58:
              _context4.next = 60;
              return;

            case 60:
              stop = _context4.sent;

              if (stop) {
                _context4.next = 73;
                break;
              }

              _context4.prev = 62;
              _context4.next = 65;
              return _asyncGenerator3.default.await(script.onStateChange());

            case 65:
              _context4.next = 73;
              break;

            case 67:
              _context4.prev = 67;
              _context4.t3 = _context4['catch'](62);
              _amError = new _appManagerError2.default(_context4.t3, (0, _assign2.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'on_state_change',
                recoverable: true
              }));
              _context4.next = 72;
              return _asyncGenerator3.default.await(handleError(_context4.t3));

            case 72:
              throw _amError;

            case 73:
              _context4.next = 36;
              break;

            case 75:
              _context4.next = 77;
              return _asyncGenerator3.default.await(unmount());

            case 77:
              _context4.next = 79;
              return _asyncGenerator3.default.await(updateStatus(defaultStatusDetails));

            case 79:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, this, [[7, 13], [19, 29], [38, 45], [62, 67]]);
    }));

    return function createLifecycle(_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();

  var handleLifecycleError = function () {
    var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(slotName, err) {
      var errorPromises;
      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              if (mountedLifecycles[slotName]) {
                delete mountedLifecycles[slotName];
              }

              errorPromises = function errorPromises() {
                return (0, _keys2.default)(mountedLifecycles).map(function (errorSlot) {
                  return mountedLifecycles[errorSlot].throw(err);
                });
              };

              _context5.next = 4;
              return _promise2.default.all(errorPromises());

            case 4:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    return function handleLifecycleError(_x6, _x7) {
      return _ref5.apply(this, arguments);
    };
  }();

  var updateAllSlots = function () {
    var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
      var updateAllSlotsPromises;
      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              updateAllSlotsPromises = function updateAllSlotsPromises() {
                return (0, _keys2.default)(mountedLifecycles).map(function (statusSlot) {
                  return mountedLifecycles[statusSlot].next(false);
                });
              };

              _context6.next = 3;
              return _promise2.default.all(updateAllSlotsPromises());

            case 3:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    return function updateAllSlots() {
      return _ref6.apply(this, arguments);
    };
  }();

  var mountedLifecycles = {};
  var cachedScripts = {};

  var loadingStatusDetails = (0, _config.getLoadingStatusDetails)();
  var defaultStatusDetails = (0, _config.getDefaultStatusDetails)();

  return function () {
    var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11(pageDiff, initialRender) {
      var _this = this;

      var unmount, mount, update, onError, slotsToUpdate, slotsToUnmount, slotsToMount, loadScriptPromises, updatePromises, unmountPromises, mountPromises, haveScripts;
      return _regenerator2.default.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              unmount = pageDiff.unmount, mount = pageDiff.mount, update = pageDiff.update;
              onError = typeof options.onError === 'function' ? options.onError : function (_err) {};
              slotsToUpdate = (0, _keys2.default)(update);
              slotsToUnmount = (0, _keys2.default)(unmount);
              slotsToMount = (0, _keys2.default)(mount);

              loadScriptPromises = function loadScriptPromises() {
                return slotsToMount.map(function () {
                  var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(slotName) {
                    var fragmentName, _script;

                    return _regenerator2.default.wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            fragmentName = mount[slotName];

                            if (!cachedScripts[fragmentName]) {
                              _context7.next = 3;
                              break;
                            }

                            return _context7.abrupt('return', true);

                          case 3:
                            _context7.prev = 3;
                            _context7.next = 6;
                            return loadScript(slotName, fragmentName);

                          case 6:
                            _script = _context7.sent;

                            if (_script) {
                              _context7.next = 9;
                              break;
                            }

                            return _context7.abrupt('return', false);

                          case 9:

                            cachedScripts[fragmentName] = _script;
                            return _context7.abrupt('return', true);

                          case 13:
                            _context7.prev = 13;
                            _context7.t0 = _context7['catch'](3);
                            _context7.next = 17;
                            return handleLifecycleError(slotName, _context7.t0);

                          case 17:
                            onError(_context7.t0);
                            return _context7.abrupt('return', false);

                          case 19:
                          case 'end':
                            return _context7.stop();
                        }
                      }
                    }, _callee7, _this, [[3, 13]]);
                  }));

                  return function (_x10) {
                    return _ref8.apply(this, arguments);
                  };
                }());
              };

              updatePromises = function updatePromises() {
                return slotsToUpdate.map(function () {
                  var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(slotName) {
                    return _regenerator2.default.wrap(function _callee8$(_context8) {
                      while (1) {
                        switch (_context8.prev = _context8.next) {
                          case 0:
                            _context8.prev = 0;

                            if (!mountedLifecycles[slotName]) {
                              _context8.next = 4;
                              break;
                            }

                            _context8.next = 4;
                            return mountedLifecycles[slotName].next(false);

                          case 4:
                            _context8.next = 11;
                            break;

                          case 6:
                            _context8.prev = 6;
                            _context8.t0 = _context8['catch'](0);
                            _context8.next = 10;
                            return handleLifecycleError(slotName, _context8.t0);

                          case 10:
                            onError(_context8.t0);

                          case 11:
                          case 'end':
                            return _context8.stop();
                        }
                      }
                    }, _callee8, _this, [[0, 6]]);
                  }));

                  return function (_x11) {
                    return _ref9.apply(this, arguments);
                  };
                }());
              };

              unmountPromises = function unmountPromises() {
                return slotsToUnmount.map(function () {
                  var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(slotName) {
                    return _regenerator2.default.wrap(function _callee9$(_context9) {
                      while (1) {
                        switch (_context9.prev = _context9.next) {
                          case 0:
                            _context9.prev = 0;

                            if (!mountedLifecycles[slotName]) {
                              _context9.next = 5;
                              break;
                            }

                            _context9.next = 4;
                            return mountedLifecycles[slotName].next(true);

                          case 4:
                            delete mountedLifecycles[slotName];

                          case 5:
                            _context9.next = 12;
                            break;

                          case 7:
                            _context9.prev = 7;
                            _context9.t0 = _context9['catch'](0);
                            _context9.next = 11;
                            return handleLifecycleError(slotName, _context9.t0);

                          case 11:
                            onError(_context9.t0);

                          case 12:
                          case 'end':
                            return _context9.stop();
                        }
                      }
                    }, _callee9, _this, [[0, 7]]);
                  }));

                  return function (_x12) {
                    return _ref10.apply(this, arguments);
                  };
                }());
              };

              mountPromises = function mountPromises() {
                return slotsToMount.map(function () {
                  var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(slotName) {
                    var fragmentName;
                    return _regenerator2.default.wrap(function _callee10$(_context10) {
                      while (1) {
                        switch (_context10.prev = _context10.next) {
                          case 0:
                            fragmentName = mount[slotName];
                            _context10.prev = 1;

                            if (!mountedLifecycles[slotName]) {
                              _context10.next = 4;
                              break;
                            }

                            throw new _appManagerError2.default('Overwriting an existing fragment.', {
                              source: 'update_page',
                              fragment: fragmentName,
                              slot: slotName,
                              level: _constants.levels.ERROR,
                              code: 'overwrite_existing',
                              recoverable: true
                            });

                          case 4:
                            _context10.next = 6;
                            return createLifecycle(slotName, fragmentName, initialRender);

                          case 6:
                            mountedLifecycles[slotName] = _context10.sent;
                            _context10.next = 9;
                            return mountedLifecycles[slotName].next(false);

                          case 9:
                            _context10.next = 16;
                            break;

                          case 11:
                            _context10.prev = 11;
                            _context10.t0 = _context10['catch'](1);
                            _context10.next = 15;
                            return handleLifecycleError(slotName, _context10.t0);

                          case 15:
                            onError(_context10.t0);

                          case 16:
                          case 'end':
                            return _context10.stop();
                        }
                      }
                    }, _callee10, _this, [[1, 11]]);
                  }));

                  return function (_x13) {
                    return _ref11.apply(this, arguments);
                  };
                }());
              };

              _context11.next = 11;
              return updateAllSlots();

            case 11:
              _context11.next = 13;
              return _promise2.default.all(updatePromises());

            case 13:
              _context11.next = 15;
              return _promise2.default.all(unmountPromises());

            case 15:
              _context11.next = 17;
              return _promise2.default.all(loadScriptPromises());

            case 17:
              haveScripts = _context11.sent;
              _context11.next = 20;
              return _promise2.default.all(mountPromises());

            case 20:
              _context11.next = 22;
              return updateAllSlots();

            case 22:
              return _context11.abrupt('return', haveScripts.every(Boolean));

            case 23:
            case 'end':
              return _context11.stop();
          }
        }
      }, _callee11, this);
    }));

    function updatePage(_x8, _x9) {
      return _ref7.apply(this, arguments);
    }

    return updatePage;
  }();
}